# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class CommonSearch(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, search_for: str=None, page: int=None, page_size: int=10, limit: int=None, offset: int=None, order_direction: str='desc', institution: int=None, published_since: str=None, modified_since: str=None, group: int=None):  # noqa: E501
        """CommonSearch - a model defined in Swagger

        :param search_for: The search_for of this CommonSearch.  # noqa: E501
        :type search_for: str
        :param page: The page of this CommonSearch.  # noqa: E501
        :type page: int
        :param page_size: The page_size of this CommonSearch.  # noqa: E501
        :type page_size: int
        :param limit: The limit of this CommonSearch.  # noqa: E501
        :type limit: int
        :param offset: The offset of this CommonSearch.  # noqa: E501
        :type offset: int
        :param order_direction: The order_direction of this CommonSearch.  # noqa: E501
        :type order_direction: str
        :param institution: The institution of this CommonSearch.  # noqa: E501
        :type institution: int
        :param published_since: The published_since of this CommonSearch.  # noqa: E501
        :type published_since: str
        :param modified_since: The modified_since of this CommonSearch.  # noqa: E501
        :type modified_since: str
        :param group: The group of this CommonSearch.  # noqa: E501
        :type group: int
        """
        self.swagger_types = {
            'search_for': str,
            'page': int,
            'page_size': int,
            'limit': int,
            'offset': int,
            'order_direction': str,
            'institution': int,
            'published_since': str,
            'modified_since': str,
            'group': int
        }

        self.attribute_map = {
            'search_for': 'search_for',
            'page': 'page',
            'page_size': 'page_size',
            'limit': 'limit',
            'offset': 'offset',
            'order_direction': 'order_direction',
            'institution': 'institution',
            'published_since': 'published_since',
            'modified_since': 'modified_since',
            'group': 'group'
        }

        self._search_for = search_for
        self._page = page
        self._page_size = page_size
        self._limit = limit
        self._offset = offset
        self._order_direction = order_direction
        self._institution = institution
        self._published_since = published_since
        self._modified_since = modified_since
        self._group = group

    @classmethod
    def from_dict(cls, dikt) -> 'CommonSearch':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The CommonSearch of this CommonSearch.  # noqa: E501
        :rtype: CommonSearch
        """
        return util.deserialize_model(dikt, cls)

    @property
    def search_for(self) -> str:
        """Gets the search_for of this CommonSearch.

        Search term  # noqa: E501

        :return: The search_for of this CommonSearch.
        :rtype: str
        """
        return self._search_for

    @search_for.setter
    def search_for(self, search_for: str):
        """Sets the search_for of this CommonSearch.

        Search term  # noqa: E501

        :param search_for: The search_for of this CommonSearch.
        :type search_for: str
        """

        self._search_for = search_for

    @property
    def page(self) -> int:
        """Gets the page of this CommonSearch.

        Page number. Used for pagination with page_size  # noqa: E501

        :return: The page of this CommonSearch.
        :rtype: int
        """
        return self._page

    @page.setter
    def page(self, page: int):
        """Sets the page of this CommonSearch.

        Page number. Used for pagination with page_size  # noqa: E501

        :param page: The page of this CommonSearch.
        :type page: int
        """
        if page is not None and page > 5000:  # noqa: E501
            raise ValueError("Invalid value for `page`, must be a value less than or equal to `5000`")  # noqa: E501
        if page is not None and page < 1:  # noqa: E501
            raise ValueError("Invalid value for `page`, must be a value greater than or equal to `1`")  # noqa: E501

        self._page = page

    @property
    def page_size(self) -> int:
        """Gets the page_size of this CommonSearch.

        The number of results included on a page. Used for pagination with page  # noqa: E501

        :return: The page_size of this CommonSearch.
        :rtype: int
        """
        return self._page_size

    @page_size.setter
    def page_size(self, page_size: int):
        """Sets the page_size of this CommonSearch.

        The number of results included on a page. Used for pagination with page  # noqa: E501

        :param page_size: The page_size of this CommonSearch.
        :type page_size: int
        """
        if page_size is not None and page_size > 1000:  # noqa: E501
            raise ValueError("Invalid value for `page_size`, must be a value less than or equal to `1000`")  # noqa: E501
        if page_size is not None and page_size < 1:  # noqa: E501
            raise ValueError("Invalid value for `page_size`, must be a value greater than or equal to `1`")  # noqa: E501

        self._page_size = page_size

    @property
    def limit(self) -> int:
        """Gets the limit of this CommonSearch.

        Number of results included on a page. Used for pagination with query  # noqa: E501

        :return: The limit of this CommonSearch.
        :rtype: int
        """
        return self._limit

    @limit.setter
    def limit(self, limit: int):
        """Sets the limit of this CommonSearch.

        Number of results included on a page. Used for pagination with query  # noqa: E501

        :param limit: The limit of this CommonSearch.
        :type limit: int
        """
        if limit is not None and limit > 1000:  # noqa: E501
            raise ValueError("Invalid value for `limit`, must be a value less than or equal to `1000`")  # noqa: E501
        if limit is not None and limit < 1:  # noqa: E501
            raise ValueError("Invalid value for `limit`, must be a value greater than or equal to `1`")  # noqa: E501

        self._limit = limit

    @property
    def offset(self) -> int:
        """Gets the offset of this CommonSearch.

        Where to start the listing(the offset of the first result). Used for pagination with limit  # noqa: E501

        :return: The offset of this CommonSearch.
        :rtype: int
        """
        return self._offset

    @offset.setter
    def offset(self, offset: int):
        """Sets the offset of this CommonSearch.

        Where to start the listing(the offset of the first result). Used for pagination with limit  # noqa: E501

        :param offset: The offset of this CommonSearch.
        :type offset: int
        """
        if offset is not None and offset > 5000:  # noqa: E501
            raise ValueError("Invalid value for `offset`, must be a value less than or equal to `5000`")  # noqa: E501
        if offset is not None and offset < 0:  # noqa: E501
            raise ValueError("Invalid value for `offset`, must be a value greater than or equal to `0`")  # noqa: E501

        self._offset = offset

    @property
    def order_direction(self) -> str:
        """Gets the order_direction of this CommonSearch.

        Direction of ordering  # noqa: E501

        :return: The order_direction of this CommonSearch.
        :rtype: str
        """
        return self._order_direction

    @order_direction.setter
    def order_direction(self, order_direction: str):
        """Sets the order_direction of this CommonSearch.

        Direction of ordering  # noqa: E501

        :param order_direction: The order_direction of this CommonSearch.
        :type order_direction: str
        """
        allowed_values = ["asc", "desc"]  # noqa: E501
        if order_direction not in allowed_values:
            raise ValueError(
                "Invalid value for `order_direction` ({0}), must be one of {1}"
                .format(order_direction, allowed_values)
            )

        self._order_direction = order_direction

    @property
    def institution(self) -> int:
        """Gets the institution of this CommonSearch.

        only return collections from this institution  # noqa: E501

        :return: The institution of this CommonSearch.
        :rtype: int
        """
        return self._institution

    @institution.setter
    def institution(self, institution: int):
        """Sets the institution of this CommonSearch.

        only return collections from this institution  # noqa: E501

        :param institution: The institution of this CommonSearch.
        :type institution: int
        """

        self._institution = institution

    @property
    def published_since(self) -> str:
        """Gets the published_since of this CommonSearch.

        Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD  # noqa: E501

        :return: The published_since of this CommonSearch.
        :rtype: str
        """
        return self._published_since

    @published_since.setter
    def published_since(self, published_since: str):
        """Sets the published_since of this CommonSearch.

        Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD  # noqa: E501

        :param published_since: The published_since of this CommonSearch.
        :type published_since: str
        """

        self._published_since = published_since

    @property
    def modified_since(self) -> str:
        """Gets the modified_since of this CommonSearch.

        Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD  # noqa: E501

        :return: The modified_since of this CommonSearch.
        :rtype: str
        """
        return self._modified_since

    @modified_since.setter
    def modified_since(self, modified_since: str):
        """Sets the modified_since of this CommonSearch.

        Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD  # noqa: E501

        :param modified_since: The modified_since of this CommonSearch.
        :type modified_since: str
        """

        self._modified_since = modified_since

    @property
    def group(self) -> int:
        """Gets the group of this CommonSearch.

        only return collections from this group  # noqa: E501

        :return: The group of this CommonSearch.
        :rtype: int
        """
        return self._group

    @group.setter
    def group(self, group: int):
        """Sets the group of this CommonSearch.

        only return collections from this group  # noqa: E501

        :param group: The group of this CommonSearch.
        :type group: int
        """

        self._group = group
