# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class FundingInformation(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, title: str=None, grant_code: str=None, funder_name: str=None, is_user_defined: int=None, url: str=None):  # noqa: E501
        """FundingInformation - a model defined in Swagger

        :param id: The id of this FundingInformation.  # noqa: E501
        :type id: int
        :param title: The title of this FundingInformation.  # noqa: E501
        :type title: str
        :param grant_code: The grant_code of this FundingInformation.  # noqa: E501
        :type grant_code: str
        :param funder_name: The funder_name of this FundingInformation.  # noqa: E501
        :type funder_name: str
        :param is_user_defined: The is_user_defined of this FundingInformation.  # noqa: E501
        :type is_user_defined: int
        :param url: The url of this FundingInformation.  # noqa: E501
        :type url: str
        """
        self.swagger_types = {
            'id': int,
            'title': str,
            'grant_code': str,
            'funder_name': str,
            'is_user_defined': int,
            'url': str
        }

        self.attribute_map = {
            'id': 'id',
            'title': 'title',
            'grant_code': 'grant_code',
            'funder_name': 'funder_name',
            'is_user_defined': 'is_user_defined',
            'url': 'url'
        }

        self._id = id
        self._title = title
        self._grant_code = grant_code
        self._funder_name = funder_name
        self._is_user_defined = is_user_defined
        self._url = url

    @classmethod
    def from_dict(cls, dikt) -> 'FundingInformation':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The FundingInformation of this FundingInformation.  # noqa: E501
        :rtype: FundingInformation
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> int:
        """Gets the id of this FundingInformation.

        Funding id  # noqa: E501

        :return: The id of this FundingInformation.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id: int):
        """Sets the id of this FundingInformation.

        Funding id  # noqa: E501

        :param id: The id of this FundingInformation.
        :type id: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def title(self) -> str:
        """Gets the title of this FundingInformation.

        The funding name  # noqa: E501

        :return: The title of this FundingInformation.
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title: str):
        """Sets the title of this FundingInformation.

        The funding name  # noqa: E501

        :param title: The title of this FundingInformation.
        :type title: str
        """
        if title is None:
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501

        self._title = title

    @property
    def grant_code(self) -> str:
        """Gets the grant_code of this FundingInformation.

        The grant code  # noqa: E501

        :return: The grant_code of this FundingInformation.
        :rtype: str
        """
        return self._grant_code

    @grant_code.setter
    def grant_code(self, grant_code: str):
        """Sets the grant_code of this FundingInformation.

        The grant code  # noqa: E501

        :param grant_code: The grant_code of this FundingInformation.
        :type grant_code: str
        """
        if grant_code is None:
            raise ValueError("Invalid value for `grant_code`, must not be `None`")  # noqa: E501

        self._grant_code = grant_code

    @property
    def funder_name(self) -> str:
        """Gets the funder_name of this FundingInformation.

        Funder's name  # noqa: E501

        :return: The funder_name of this FundingInformation.
        :rtype: str
        """
        return self._funder_name

    @funder_name.setter
    def funder_name(self, funder_name: str):
        """Sets the funder_name of this FundingInformation.

        Funder's name  # noqa: E501

        :param funder_name: The funder_name of this FundingInformation.
        :type funder_name: str
        """
        if funder_name is None:
            raise ValueError("Invalid value for `funder_name`, must not be `None`")  # noqa: E501

        self._funder_name = funder_name

    @property
    def is_user_defined(self) -> int:
        """Gets the is_user_defined of this FundingInformation.

        Return 1 whether the grant has been introduced manually, 0 otherwise  # noqa: E501

        :return: The is_user_defined of this FundingInformation.
        :rtype: int
        """
        return self._is_user_defined

    @is_user_defined.setter
    def is_user_defined(self, is_user_defined: int):
        """Sets the is_user_defined of this FundingInformation.

        Return 1 whether the grant has been introduced manually, 0 otherwise  # noqa: E501

        :param is_user_defined: The is_user_defined of this FundingInformation.
        :type is_user_defined: int
        """
        if is_user_defined is None:
            raise ValueError("Invalid value for `is_user_defined`, must not be `None`")  # noqa: E501

        self._is_user_defined = is_user_defined

    @property
    def url(self) -> str:
        """Gets the url of this FundingInformation.

        The grant url  # noqa: E501

        :return: The url of this FundingInformation.
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url: str):
        """Sets the url of this FundingInformation.

        The grant url  # noqa: E501

        :param url: The url of this FundingInformation.
        :type url: str
        """
        if url is None:
            raise ValueError("Invalid value for `url`, must not be `None`")  # noqa: E501

        self._url = url
