# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.article import Article
from swagger_server.models.category import Category
from swagger_server.models.funding_information import FundingInformation
from swagger_server.models.license import License
from swagger_server.models.related_material import RelatedMaterial
from swagger_server.models.timeline import Timeline
from swagger_server import util


class ProjectArticle(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, title: str=None, doi: str=None, handle: str=None, url: str=None, url_public_html: str=None, url_public_api: str=None, url_private_html: str=None, url_private_api: str=None, timeline: Timeline=None, thumb: str=None, defined_type: int=None, defined_type_name: str=None, citation: str=None, confidential_reason: str=None, is_confidential: bool=None, size: int=None, funding: str=None, funding_list: List[FundingInformation]=None, tags: List[str]=None, version: int=None, is_active: bool=None, is_metadata_record: bool=None, metadata_reason: str=None, status: str=None, description: str=None, is_embargoed: bool=None, is_public: bool=None, created_date: str=None, has_linked_file: bool=None, categories: List[Category]=None, license: License=None, embargo_title: str=None, embargo_reason: str=None, references: List[str]=None, related_materials: List[RelatedMaterial]=None):  # noqa: E501
        """ProjectArticle - a model defined in Swagger

        :param id: The id of this ProjectArticle.  # noqa: E501
        :type id: int
        :param title: The title of this ProjectArticle.  # noqa: E501
        :type title: str
        :param doi: The doi of this ProjectArticle.  # noqa: E501
        :type doi: str
        :param handle: The handle of this ProjectArticle.  # noqa: E501
        :type handle: str
        :param url: The url of this ProjectArticle.  # noqa: E501
        :type url: str
        :param url_public_html: The url_public_html of this ProjectArticle.  # noqa: E501
        :type url_public_html: str
        :param url_public_api: The url_public_api of this ProjectArticle.  # noqa: E501
        :type url_public_api: str
        :param url_private_html: The url_private_html of this ProjectArticle.  # noqa: E501
        :type url_private_html: str
        :param url_private_api: The url_private_api of this ProjectArticle.  # noqa: E501
        :type url_private_api: str
        :param timeline: The timeline of this ProjectArticle.  # noqa: E501
        :type timeline: Timeline
        :param thumb: The thumb of this ProjectArticle.  # noqa: E501
        :type thumb: str
        :param defined_type: The defined_type of this ProjectArticle.  # noqa: E501
        :type defined_type: int
        :param defined_type_name: The defined_type_name of this ProjectArticle.  # noqa: E501
        :type defined_type_name: str
        :param citation: The citation of this ProjectArticle.  # noqa: E501
        :type citation: str
        :param confidential_reason: The confidential_reason of this ProjectArticle.  # noqa: E501
        :type confidential_reason: str
        :param is_confidential: The is_confidential of this ProjectArticle.  # noqa: E501
        :type is_confidential: bool
        :param size: The size of this ProjectArticle.  # noqa: E501
        :type size: int
        :param funding: The funding of this ProjectArticle.  # noqa: E501
        :type funding: str
        :param funding_list: The funding_list of this ProjectArticle.  # noqa: E501
        :type funding_list: List[FundingInformation]
        :param tags: The tags of this ProjectArticle.  # noqa: E501
        :type tags: List[str]
        :param version: The version of this ProjectArticle.  # noqa: E501
        :type version: int
        :param is_active: The is_active of this ProjectArticle.  # noqa: E501
        :type is_active: bool
        :param is_metadata_record: The is_metadata_record of this ProjectArticle.  # noqa: E501
        :type is_metadata_record: bool
        :param metadata_reason: The metadata_reason of this ProjectArticle.  # noqa: E501
        :type metadata_reason: str
        :param status: The status of this ProjectArticle.  # noqa: E501
        :type status: str
        :param description: The description of this ProjectArticle.  # noqa: E501
        :type description: str
        :param is_embargoed: The is_embargoed of this ProjectArticle.  # noqa: E501
        :type is_embargoed: bool
        :param is_public: The is_public of this ProjectArticle.  # noqa: E501
        :type is_public: bool
        :param created_date: The created_date of this ProjectArticle.  # noqa: E501
        :type created_date: str
        :param has_linked_file: The has_linked_file of this ProjectArticle.  # noqa: E501
        :type has_linked_file: bool
        :param categories: The categories of this ProjectArticle.  # noqa: E501
        :type categories: List[Category]
        :param license: The license of this ProjectArticle.  # noqa: E501
        :type license: License
        :param embargo_title: The embargo_title of this ProjectArticle.  # noqa: E501
        :type embargo_title: str
        :param embargo_reason: The embargo_reason of this ProjectArticle.  # noqa: E501
        :type embargo_reason: str
        :param references: The references of this ProjectArticle.  # noqa: E501
        :type references: List[str]
        :param related_materials: The related_materials of this ProjectArticle.  # noqa: E501
        :type related_materials: List[RelatedMaterial]
        """
        self.swagger_types = {
            'id': int,
            'title': str,
            'doi': str,
            'handle': str,
            'url': str,
            'url_public_html': str,
            'url_public_api': str,
            'url_private_html': str,
            'url_private_api': str,
            'timeline': Timeline,
            'thumb': str,
            'defined_type': int,
            'defined_type_name': str,
            'citation': str,
            'confidential_reason': str,
            'is_confidential': bool,
            'size': int,
            'funding': str,
            'funding_list': List[FundingInformation],
            'tags': List[str],
            'version': int,
            'is_active': bool,
            'is_metadata_record': bool,
            'metadata_reason': str,
            'status': str,
            'description': str,
            'is_embargoed': bool,
            'is_public': bool,
            'created_date': str,
            'has_linked_file': bool,
            'categories': List[Category],
            'license': License,
            'embargo_title': str,
            'embargo_reason': str,
            'references': List[str],
            'related_materials': List[RelatedMaterial]
        }

        self.attribute_map = {
            'id': 'id',
            'title': 'title',
            'doi': 'doi',
            'handle': 'handle',
            'url': 'url',
            'url_public_html': 'url_public_html',
            'url_public_api': 'url_public_api',
            'url_private_html': 'url_private_html',
            'url_private_api': 'url_private_api',
            'timeline': 'timeline',
            'thumb': 'thumb',
            'defined_type': 'defined_type',
            'defined_type_name': 'defined_type_name',
            'citation': 'citation',
            'confidential_reason': 'confidential_reason',
            'is_confidential': 'is_confidential',
            'size': 'size',
            'funding': 'funding',
            'funding_list': 'funding_list',
            'tags': 'tags',
            'version': 'version',
            'is_active': 'is_active',
            'is_metadata_record': 'is_metadata_record',
            'metadata_reason': 'metadata_reason',
            'status': 'status',
            'description': 'description',
            'is_embargoed': 'is_embargoed',
            'is_public': 'is_public',
            'created_date': 'created_date',
            'has_linked_file': 'has_linked_file',
            'categories': 'categories',
            'license': 'license',
            'embargo_title': 'embargo_title',
            'embargo_reason': 'embargo_reason',
            'references': 'references',
            'related_materials': 'related_materials'
        }

        self._id = id
        self._title = title
        self._doi = doi
        self._handle = handle
        self._url = url
        self._url_public_html = url_public_html
        self._url_public_api = url_public_api
        self._url_private_html = url_private_html
        self._url_private_api = url_private_api
        self._timeline = timeline
        self._thumb = thumb
        self._defined_type = defined_type
        self._defined_type_name = defined_type_name
        self._citation = citation
        self._confidential_reason = confidential_reason
        self._is_confidential = is_confidential
        self._size = size
        self._funding = funding
        self._funding_list = funding_list
        self._tags = tags
        self._version = version
        self._is_active = is_active
        self._is_metadata_record = is_metadata_record
        self._metadata_reason = metadata_reason
        self._status = status
        self._description = description
        self._is_embargoed = is_embargoed
        self._is_public = is_public
        self._created_date = created_date
        self._has_linked_file = has_linked_file
        self._categories = categories
        self._license = license
        self._embargo_title = embargo_title
        self._embargo_reason = embargo_reason
        self._references = references
        self._related_materials = related_materials

    @classmethod
    def from_dict(cls, dikt) -> 'ProjectArticle':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The ProjectArticle of this ProjectArticle.  # noqa: E501
        :rtype: ProjectArticle
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> int:
        """Gets the id of this ProjectArticle.

        Unique identifier for article  # noqa: E501

        :return: The id of this ProjectArticle.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id: int):
        """Sets the id of this ProjectArticle.

        Unique identifier for article  # noqa: E501

        :param id: The id of this ProjectArticle.
        :type id: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def title(self) -> str:
        """Gets the title of this ProjectArticle.

        Title of article  # noqa: E501

        :return: The title of this ProjectArticle.
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title: str):
        """Sets the title of this ProjectArticle.

        Title of article  # noqa: E501

        :param title: The title of this ProjectArticle.
        :type title: str
        """
        if title is None:
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501

        self._title = title

    @property
    def doi(self) -> str:
        """Gets the doi of this ProjectArticle.

        DOI  # noqa: E501

        :return: The doi of this ProjectArticle.
        :rtype: str
        """
        return self._doi

    @doi.setter
    def doi(self, doi: str):
        """Sets the doi of this ProjectArticle.

        DOI  # noqa: E501

        :param doi: The doi of this ProjectArticle.
        :type doi: str
        """
        if doi is None:
            raise ValueError("Invalid value for `doi`, must not be `None`")  # noqa: E501

        self._doi = doi

    @property
    def handle(self) -> str:
        """Gets the handle of this ProjectArticle.

        Handle  # noqa: E501

        :return: The handle of this ProjectArticle.
        :rtype: str
        """
        return self._handle

    @handle.setter
    def handle(self, handle: str):
        """Sets the handle of this ProjectArticle.

        Handle  # noqa: E501

        :param handle: The handle of this ProjectArticle.
        :type handle: str
        """
        if handle is None:
            raise ValueError("Invalid value for `handle`, must not be `None`")  # noqa: E501

        self._handle = handle

    @property
    def url(self) -> str:
        """Gets the url of this ProjectArticle.

        Api endpoint for article  # noqa: E501

        :return: The url of this ProjectArticle.
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url: str):
        """Sets the url of this ProjectArticle.

        Api endpoint for article  # noqa: E501

        :param url: The url of this ProjectArticle.
        :type url: str
        """
        if url is None:
            raise ValueError("Invalid value for `url`, must not be `None`")  # noqa: E501

        self._url = url

    @property
    def url_public_html(self) -> str:
        """Gets the url_public_html of this ProjectArticle.

        Public site endpoint for article  # noqa: E501

        :return: The url_public_html of this ProjectArticle.
        :rtype: str
        """
        return self._url_public_html

    @url_public_html.setter
    def url_public_html(self, url_public_html: str):
        """Sets the url_public_html of this ProjectArticle.

        Public site endpoint for article  # noqa: E501

        :param url_public_html: The url_public_html of this ProjectArticle.
        :type url_public_html: str
        """
        if url_public_html is None:
            raise ValueError("Invalid value for `url_public_html`, must not be `None`")  # noqa: E501

        self._url_public_html = url_public_html

    @property
    def url_public_api(self) -> str:
        """Gets the url_public_api of this ProjectArticle.

        Public Api endpoint for article  # noqa: E501

        :return: The url_public_api of this ProjectArticle.
        :rtype: str
        """
        return self._url_public_api

    @url_public_api.setter
    def url_public_api(self, url_public_api: str):
        """Sets the url_public_api of this ProjectArticle.

        Public Api endpoint for article  # noqa: E501

        :param url_public_api: The url_public_api of this ProjectArticle.
        :type url_public_api: str
        """
        if url_public_api is None:
            raise ValueError("Invalid value for `url_public_api`, must not be `None`")  # noqa: E501

        self._url_public_api = url_public_api

    @property
    def url_private_html(self) -> str:
        """Gets the url_private_html of this ProjectArticle.

        Private site endpoint for article  # noqa: E501

        :return: The url_private_html of this ProjectArticle.
        :rtype: str
        """
        return self._url_private_html

    @url_private_html.setter
    def url_private_html(self, url_private_html: str):
        """Sets the url_private_html of this ProjectArticle.

        Private site endpoint for article  # noqa: E501

        :param url_private_html: The url_private_html of this ProjectArticle.
        :type url_private_html: str
        """
        if url_private_html is None:
            raise ValueError("Invalid value for `url_private_html`, must not be `None`")  # noqa: E501

        self._url_private_html = url_private_html

    @property
    def url_private_api(self) -> str:
        """Gets the url_private_api of this ProjectArticle.

        Private Api endpoint for article  # noqa: E501

        :return: The url_private_api of this ProjectArticle.
        :rtype: str
        """
        return self._url_private_api

    @url_private_api.setter
    def url_private_api(self, url_private_api: str):
        """Sets the url_private_api of this ProjectArticle.

        Private Api endpoint for article  # noqa: E501

        :param url_private_api: The url_private_api of this ProjectArticle.
        :type url_private_api: str
        """
        if url_private_api is None:
            raise ValueError("Invalid value for `url_private_api`, must not be `None`")  # noqa: E501

        self._url_private_api = url_private_api

    @property
    def timeline(self) -> Timeline:
        """Gets the timeline of this ProjectArticle.

        Various timeline dates  # noqa: E501

        :return: The timeline of this ProjectArticle.
        :rtype: Timeline
        """
        return self._timeline

    @timeline.setter
    def timeline(self, timeline: Timeline):
        """Sets the timeline of this ProjectArticle.

        Various timeline dates  # noqa: E501

        :param timeline: The timeline of this ProjectArticle.
        :type timeline: Timeline
        """
        if timeline is None:
            raise ValueError("Invalid value for `timeline`, must not be `None`")  # noqa: E501

        self._timeline = timeline

    @property
    def thumb(self) -> str:
        """Gets the thumb of this ProjectArticle.

        Thumbnail image  # noqa: E501

        :return: The thumb of this ProjectArticle.
        :rtype: str
        """
        return self._thumb

    @thumb.setter
    def thumb(self, thumb: str):
        """Sets the thumb of this ProjectArticle.

        Thumbnail image  # noqa: E501

        :param thumb: The thumb of this ProjectArticle.
        :type thumb: str
        """
        if thumb is None:
            raise ValueError("Invalid value for `thumb`, must not be `None`")  # noqa: E501

        self._thumb = thumb

    @property
    def defined_type(self) -> int:
        """Gets the defined_type of this ProjectArticle.

        Type of article identifier  # noqa: E501

        :return: The defined_type of this ProjectArticle.
        :rtype: int
        """
        return self._defined_type

    @defined_type.setter
    def defined_type(self, defined_type: int):
        """Sets the defined_type of this ProjectArticle.

        Type of article identifier  # noqa: E501

        :param defined_type: The defined_type of this ProjectArticle.
        :type defined_type: int
        """
        if defined_type is None:
            raise ValueError("Invalid value for `defined_type`, must not be `None`")  # noqa: E501

        self._defined_type = defined_type

    @property
    def defined_type_name(self) -> str:
        """Gets the defined_type_name of this ProjectArticle.

        Name of the article type identifier  # noqa: E501

        :return: The defined_type_name of this ProjectArticle.
        :rtype: str
        """
        return self._defined_type_name

    @defined_type_name.setter
    def defined_type_name(self, defined_type_name: str):
        """Sets the defined_type_name of this ProjectArticle.

        Name of the article type identifier  # noqa: E501

        :param defined_type_name: The defined_type_name of this ProjectArticle.
        :type defined_type_name: str
        """
        if defined_type_name is None:
            raise ValueError("Invalid value for `defined_type_name`, must not be `None`")  # noqa: E501

        self._defined_type_name = defined_type_name

    @property
    def citation(self) -> str:
        """Gets the citation of this ProjectArticle.

        Article citation  # noqa: E501

        :return: The citation of this ProjectArticle.
        :rtype: str
        """
        return self._citation

    @citation.setter
    def citation(self, citation: str):
        """Sets the citation of this ProjectArticle.

        Article citation  # noqa: E501

        :param citation: The citation of this ProjectArticle.
        :type citation: str
        """
        if citation is None:
            raise ValueError("Invalid value for `citation`, must not be `None`")  # noqa: E501

        self._citation = citation

    @property
    def confidential_reason(self) -> str:
        """Gets the confidential_reason of this ProjectArticle.

        Confidentiality reason  # noqa: E501

        :return: The confidential_reason of this ProjectArticle.
        :rtype: str
        """
        return self._confidential_reason

    @confidential_reason.setter
    def confidential_reason(self, confidential_reason: str):
        """Sets the confidential_reason of this ProjectArticle.

        Confidentiality reason  # noqa: E501

        :param confidential_reason: The confidential_reason of this ProjectArticle.
        :type confidential_reason: str
        """
        if confidential_reason is None:
            raise ValueError("Invalid value for `confidential_reason`, must not be `None`")  # noqa: E501

        self._confidential_reason = confidential_reason

    @property
    def is_confidential(self) -> bool:
        """Gets the is_confidential of this ProjectArticle.

        Article Confidentiality  # noqa: E501

        :return: The is_confidential of this ProjectArticle.
        :rtype: bool
        """
        return self._is_confidential

    @is_confidential.setter
    def is_confidential(self, is_confidential: bool):
        """Sets the is_confidential of this ProjectArticle.

        Article Confidentiality  # noqa: E501

        :param is_confidential: The is_confidential of this ProjectArticle.
        :type is_confidential: bool
        """
        if is_confidential is None:
            raise ValueError("Invalid value for `is_confidential`, must not be `None`")  # noqa: E501

        self._is_confidential = is_confidential

    @property
    def size(self) -> int:
        """Gets the size of this ProjectArticle.

        Article size  # noqa: E501

        :return: The size of this ProjectArticle.
        :rtype: int
        """
        return self._size

    @size.setter
    def size(self, size: int):
        """Sets the size of this ProjectArticle.

        Article size  # noqa: E501

        :param size: The size of this ProjectArticle.
        :type size: int
        """
        if size is None:
            raise ValueError("Invalid value for `size`, must not be `None`")  # noqa: E501

        self._size = size

    @property
    def funding(self) -> str:
        """Gets the funding of this ProjectArticle.

        Article funding  # noqa: E501

        :return: The funding of this ProjectArticle.
        :rtype: str
        """
        return self._funding

    @funding.setter
    def funding(self, funding: str):
        """Sets the funding of this ProjectArticle.

        Article funding  # noqa: E501

        :param funding: The funding of this ProjectArticle.
        :type funding: str
        """
        if funding is None:
            raise ValueError("Invalid value for `funding`, must not be `None`")  # noqa: E501

        self._funding = funding

    @property
    def funding_list(self) -> List[FundingInformation]:
        """Gets the funding_list of this ProjectArticle.

        Full Article funding information  # noqa: E501

        :return: The funding_list of this ProjectArticle.
        :rtype: List[FundingInformation]
        """
        return self._funding_list

    @funding_list.setter
    def funding_list(self, funding_list: List[FundingInformation]):
        """Sets the funding_list of this ProjectArticle.

        Full Article funding information  # noqa: E501

        :param funding_list: The funding_list of this ProjectArticle.
        :type funding_list: List[FundingInformation]
        """
        if funding_list is None:
            raise ValueError("Invalid value for `funding_list`, must not be `None`")  # noqa: E501

        self._funding_list = funding_list

    @property
    def tags(self) -> List[str]:
        """Gets the tags of this ProjectArticle.

        List of article tags  # noqa: E501

        :return: The tags of this ProjectArticle.
        :rtype: List[str]
        """
        return self._tags

    @tags.setter
    def tags(self, tags: List[str]):
        """Sets the tags of this ProjectArticle.

        List of article tags  # noqa: E501

        :param tags: The tags of this ProjectArticle.
        :type tags: List[str]
        """
        if tags is None:
            raise ValueError("Invalid value for `tags`, must not be `None`")  # noqa: E501

        self._tags = tags

    @property
    def version(self) -> int:
        """Gets the version of this ProjectArticle.

        Article version  # noqa: E501

        :return: The version of this ProjectArticle.
        :rtype: int
        """
        return self._version

    @version.setter
    def version(self, version: int):
        """Sets the version of this ProjectArticle.

        Article version  # noqa: E501

        :param version: The version of this ProjectArticle.
        :type version: int
        """
        if version is None:
            raise ValueError("Invalid value for `version`, must not be `None`")  # noqa: E501

        self._version = version

    @property
    def is_active(self) -> bool:
        """Gets the is_active of this ProjectArticle.

        True if article is active  # noqa: E501

        :return: The is_active of this ProjectArticle.
        :rtype: bool
        """
        return self._is_active

    @is_active.setter
    def is_active(self, is_active: bool):
        """Sets the is_active of this ProjectArticle.

        True if article is active  # noqa: E501

        :param is_active: The is_active of this ProjectArticle.
        :type is_active: bool
        """
        if is_active is None:
            raise ValueError("Invalid value for `is_active`, must not be `None`")  # noqa: E501

        self._is_active = is_active

    @property
    def is_metadata_record(self) -> bool:
        """Gets the is_metadata_record of this ProjectArticle.

        True if article has no files  # noqa: E501

        :return: The is_metadata_record of this ProjectArticle.
        :rtype: bool
        """
        return self._is_metadata_record

    @is_metadata_record.setter
    def is_metadata_record(self, is_metadata_record: bool):
        """Sets the is_metadata_record of this ProjectArticle.

        True if article has no files  # noqa: E501

        :param is_metadata_record: The is_metadata_record of this ProjectArticle.
        :type is_metadata_record: bool
        """
        if is_metadata_record is None:
            raise ValueError("Invalid value for `is_metadata_record`, must not be `None`")  # noqa: E501

        self._is_metadata_record = is_metadata_record

    @property
    def metadata_reason(self) -> str:
        """Gets the metadata_reason of this ProjectArticle.

        Article metadata reason  # noqa: E501

        :return: The metadata_reason of this ProjectArticle.
        :rtype: str
        """
        return self._metadata_reason

    @metadata_reason.setter
    def metadata_reason(self, metadata_reason: str):
        """Sets the metadata_reason of this ProjectArticle.

        Article metadata reason  # noqa: E501

        :param metadata_reason: The metadata_reason of this ProjectArticle.
        :type metadata_reason: str
        """
        if metadata_reason is None:
            raise ValueError("Invalid value for `metadata_reason`, must not be `None`")  # noqa: E501

        self._metadata_reason = metadata_reason

    @property
    def status(self) -> str:
        """Gets the status of this ProjectArticle.

        Article status  # noqa: E501

        :return: The status of this ProjectArticle.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status: str):
        """Sets the status of this ProjectArticle.

        Article status  # noqa: E501

        :param status: The status of this ProjectArticle.
        :type status: str
        """
        if status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501

        self._status = status

    @property
    def description(self) -> str:
        """Gets the description of this ProjectArticle.

        Article description  # noqa: E501

        :return: The description of this ProjectArticle.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description: str):
        """Sets the description of this ProjectArticle.

        Article description  # noqa: E501

        :param description: The description of this ProjectArticle.
        :type description: str
        """
        if description is None:
            raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501

        self._description = description

    @property
    def is_embargoed(self) -> bool:
        """Gets the is_embargoed of this ProjectArticle.

        True if article is embargoed  # noqa: E501

        :return: The is_embargoed of this ProjectArticle.
        :rtype: bool
        """
        return self._is_embargoed

    @is_embargoed.setter
    def is_embargoed(self, is_embargoed: bool):
        """Sets the is_embargoed of this ProjectArticle.

        True if article is embargoed  # noqa: E501

        :param is_embargoed: The is_embargoed of this ProjectArticle.
        :type is_embargoed: bool
        """
        if is_embargoed is None:
            raise ValueError("Invalid value for `is_embargoed`, must not be `None`")  # noqa: E501

        self._is_embargoed = is_embargoed

    @property
    def is_public(self) -> bool:
        """Gets the is_public of this ProjectArticle.

        True if article is published  # noqa: E501

        :return: The is_public of this ProjectArticle.
        :rtype: bool
        """
        return self._is_public

    @is_public.setter
    def is_public(self, is_public: bool):
        """Sets the is_public of this ProjectArticle.

        True if article is published  # noqa: E501

        :param is_public: The is_public of this ProjectArticle.
        :type is_public: bool
        """
        if is_public is None:
            raise ValueError("Invalid value for `is_public`, must not be `None`")  # noqa: E501

        self._is_public = is_public

    @property
    def created_date(self) -> str:
        """Gets the created_date of this ProjectArticle.

        Date when article was created  # noqa: E501

        :return: The created_date of this ProjectArticle.
        :rtype: str
        """
        return self._created_date

    @created_date.setter
    def created_date(self, created_date: str):
        """Sets the created_date of this ProjectArticle.

        Date when article was created  # noqa: E501

        :param created_date: The created_date of this ProjectArticle.
        :type created_date: str
        """
        if created_date is None:
            raise ValueError("Invalid value for `created_date`, must not be `None`")  # noqa: E501

        self._created_date = created_date

    @property
    def has_linked_file(self) -> bool:
        """Gets the has_linked_file of this ProjectArticle.

        True if any files are linked to the article  # noqa: E501

        :return: The has_linked_file of this ProjectArticle.
        :rtype: bool
        """
        return self._has_linked_file

    @has_linked_file.setter
    def has_linked_file(self, has_linked_file: bool):
        """Sets the has_linked_file of this ProjectArticle.

        True if any files are linked to the article  # noqa: E501

        :param has_linked_file: The has_linked_file of this ProjectArticle.
        :type has_linked_file: bool
        """
        if has_linked_file is None:
            raise ValueError("Invalid value for `has_linked_file`, must not be `None`")  # noqa: E501

        self._has_linked_file = has_linked_file

    @property
    def categories(self) -> List[Category]:
        """Gets the categories of this ProjectArticle.

        List of categories selected for the article  # noqa: E501

        :return: The categories of this ProjectArticle.
        :rtype: List[Category]
        """
        return self._categories

    @categories.setter
    def categories(self, categories: List[Category]):
        """Sets the categories of this ProjectArticle.

        List of categories selected for the article  # noqa: E501

        :param categories: The categories of this ProjectArticle.
        :type categories: List[Category]
        """
        if categories is None:
            raise ValueError("Invalid value for `categories`, must not be `None`")  # noqa: E501

        self._categories = categories

    @property
    def license(self) -> License:
        """Gets the license of this ProjectArticle.

        Article selected license  # noqa: E501

        :return: The license of this ProjectArticle.
        :rtype: License
        """
        return self._license

    @license.setter
    def license(self, license: License):
        """Sets the license of this ProjectArticle.

        Article selected license  # noqa: E501

        :param license: The license of this ProjectArticle.
        :type license: License
        """
        if license is None:
            raise ValueError("Invalid value for `license`, must not be `None`")  # noqa: E501

        self._license = license

    @property
    def embargo_title(self) -> str:
        """Gets the embargo_title of this ProjectArticle.

        Title for embargo  # noqa: E501

        :return: The embargo_title of this ProjectArticle.
        :rtype: str
        """
        return self._embargo_title

    @embargo_title.setter
    def embargo_title(self, embargo_title: str):
        """Sets the embargo_title of this ProjectArticle.

        Title for embargo  # noqa: E501

        :param embargo_title: The embargo_title of this ProjectArticle.
        :type embargo_title: str
        """
        if embargo_title is None:
            raise ValueError("Invalid value for `embargo_title`, must not be `None`")  # noqa: E501

        self._embargo_title = embargo_title

    @property
    def embargo_reason(self) -> str:
        """Gets the embargo_reason of this ProjectArticle.

        Reason for embargo  # noqa: E501

        :return: The embargo_reason of this ProjectArticle.
        :rtype: str
        """
        return self._embargo_reason

    @embargo_reason.setter
    def embargo_reason(self, embargo_reason: str):
        """Sets the embargo_reason of this ProjectArticle.

        Reason for embargo  # noqa: E501

        :param embargo_reason: The embargo_reason of this ProjectArticle.
        :type embargo_reason: str
        """
        if embargo_reason is None:
            raise ValueError("Invalid value for `embargo_reason`, must not be `None`")  # noqa: E501

        self._embargo_reason = embargo_reason

    @property
    def references(self) -> List[str]:
        """Gets the references of this ProjectArticle.

        List of references  # noqa: E501

        :return: The references of this ProjectArticle.
        :rtype: List[str]
        """
        return self._references

    @references.setter
    def references(self, references: List[str]):
        """Sets the references of this ProjectArticle.

        List of references  # noqa: E501

        :param references: The references of this ProjectArticle.
        :type references: List[str]
        """
        if references is None:
            raise ValueError("Invalid value for `references`, must not be `None`")  # noqa: E501

        self._references = references

    @property
    def related_materials(self) -> List[RelatedMaterial]:
        """Gets the related_materials of this ProjectArticle.

        List of related materials; supersedes references and resource DOI/title.  # noqa: E501

        :return: The related_materials of this ProjectArticle.
        :rtype: List[RelatedMaterial]
        """
        return self._related_materials

    @related_materials.setter
    def related_materials(self, related_materials: List[RelatedMaterial]):
        """Sets the related_materials of this ProjectArticle.

        List of related materials; supersedes references and resource DOI/title.  # noqa: E501

        :param related_materials: The related_materials of this ProjectArticle.
        :type related_materials: List[RelatedMaterial]
        """

        self._related_materials = related_materials
