# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.custom_article_field_add import CustomArticleFieldAdd
from swagger_server.models.funding_create import FundingCreate
from swagger_server import util


class ProjectCreate(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, title: str=None, description: str=None, funding: str=None, funding_list: List[FundingCreate]=None, group_id: int=None, custom_fields: object=None, custom_fields_list: List[CustomArticleFieldAdd]=None):  # noqa: E501
        """ProjectCreate - a model defined in Swagger

        :param title: The title of this ProjectCreate.  # noqa: E501
        :type title: str
        :param description: The description of this ProjectCreate.  # noqa: E501
        :type description: str
        :param funding: The funding of this ProjectCreate.  # noqa: E501
        :type funding: str
        :param funding_list: The funding_list of this ProjectCreate.  # noqa: E501
        :type funding_list: List[FundingCreate]
        :param group_id: The group_id of this ProjectCreate.  # noqa: E501
        :type group_id: int
        :param custom_fields: The custom_fields of this ProjectCreate.  # noqa: E501
        :type custom_fields: object
        :param custom_fields_list: The custom_fields_list of this ProjectCreate.  # noqa: E501
        :type custom_fields_list: List[CustomArticleFieldAdd]
        """
        self.swagger_types = {
            'title': str,
            'description': str,
            'funding': str,
            'funding_list': List[FundingCreate],
            'group_id': int,
            'custom_fields': object,
            'custom_fields_list': List[CustomArticleFieldAdd]
        }

        self.attribute_map = {
            'title': 'title',
            'description': 'description',
            'funding': 'funding',
            'funding_list': 'funding_list',
            'group_id': 'group_id',
            'custom_fields': 'custom_fields',
            'custom_fields_list': 'custom_fields_list'
        }

        self._title = title
        self._description = description
        self._funding = funding
        self._funding_list = funding_list
        self._group_id = group_id
        self._custom_fields = custom_fields
        self._custom_fields_list = custom_fields_list

    @classmethod
    def from_dict(cls, dikt) -> 'ProjectCreate':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The ProjectCreate of this ProjectCreate.  # noqa: E501
        :rtype: ProjectCreate
        """
        return util.deserialize_model(dikt, cls)

    @property
    def title(self) -> str:
        """Gets the title of this ProjectCreate.

        The title for this project - mandatory. 3 - 1000 characters.  # noqa: E501

        :return: The title of this ProjectCreate.
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title: str):
        """Sets the title of this ProjectCreate.

        The title for this project - mandatory. 3 - 1000 characters.  # noqa: E501

        :param title: The title of this ProjectCreate.
        :type title: str
        """
        if title is None:
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501
        if title is not None and len(title) > 1000:
            raise ValueError("Invalid value for `title`, length must be less than or equal to `1000`")  # noqa: E501
        if title is not None and len(title) < 3:
            raise ValueError("Invalid value for `title`, length must be greater than or equal to `3`")  # noqa: E501

        self._title = title

    @property
    def description(self) -> str:
        """Gets the description of this ProjectCreate.

        Project description  # noqa: E501

        :return: The description of this ProjectCreate.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description: str):
        """Sets the description of this ProjectCreate.

        Project description  # noqa: E501

        :param description: The description of this ProjectCreate.
        :type description: str
        """
        if description is not None and len(description) > 10000:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `10000`")  # noqa: E501

        self._description = description

    @property
    def funding(self) -> str:
        """Gets the funding of this ProjectCreate.

        Grant number or organization(s) that funded this project. Up to 2000 characters permitted.  # noqa: E501

        :return: The funding of this ProjectCreate.
        :rtype: str
        """
        return self._funding

    @funding.setter
    def funding(self, funding: str):
        """Sets the funding of this ProjectCreate.

        Grant number or organization(s) that funded this project. Up to 2000 characters permitted.  # noqa: E501

        :param funding: The funding of this ProjectCreate.
        :type funding: str
        """

        self._funding = funding

    @property
    def funding_list(self) -> List[FundingCreate]:
        """Gets the funding_list of this ProjectCreate.

        Funding creation / update items  # noqa: E501

        :return: The funding_list of this ProjectCreate.
        :rtype: List[FundingCreate]
        """
        return self._funding_list

    @funding_list.setter
    def funding_list(self, funding_list: List[FundingCreate]):
        """Sets the funding_list of this ProjectCreate.

        Funding creation / update items  # noqa: E501

        :param funding_list: The funding_list of this ProjectCreate.
        :type funding_list: List[FundingCreate]
        """

        self._funding_list = funding_list

    @property
    def group_id(self) -> int:
        """Gets the group_id of this ProjectCreate.

        Only if project type is group.  # noqa: E501

        :return: The group_id of this ProjectCreate.
        :rtype: int
        """
        return self._group_id

    @group_id.setter
    def group_id(self, group_id: int):
        """Sets the group_id of this ProjectCreate.

        Only if project type is group.  # noqa: E501

        :param group_id: The group_id of this ProjectCreate.
        :type group_id: int
        """

        self._group_id = group_id

    @property
    def custom_fields(self) -> object:
        """Gets the custom_fields of this ProjectCreate.

        List of key, values pairs to be associated with the project  # noqa: E501

        :return: The custom_fields of this ProjectCreate.
        :rtype: object
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields: object):
        """Sets the custom_fields of this ProjectCreate.

        List of key, values pairs to be associated with the project  # noqa: E501

        :param custom_fields: The custom_fields of this ProjectCreate.
        :type custom_fields: object
        """

        self._custom_fields = custom_fields

    @property
    def custom_fields_list(self) -> List[CustomArticleFieldAdd]:
        """Gets the custom_fields_list of this ProjectCreate.

        List of custom fields values, supersedes custom_fields parameter  # noqa: E501

        :return: The custom_fields_list of this ProjectCreate.
        :rtype: List[CustomArticleFieldAdd]
        """
        return self._custom_fields_list

    @custom_fields_list.setter
    def custom_fields_list(self, custom_fields_list: List[CustomArticleFieldAdd]):
        """Sets the custom_fields_list of this ProjectCreate.

        List of custom fields values, supersedes custom_fields parameter  # noqa: E501

        :param custom_fields_list: The custom_fields_list of this ProjectCreate.
        :type custom_fields_list: List[CustomArticleFieldAdd]
        """

        self._custom_fields_list = custom_fields_list
