# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class RelatedMaterial(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, identifier: str=None, title: str=None, relation: str='References', identifier_type: str='URL', is_linkout: bool=None, link: str=None):  # noqa: E501
        """RelatedMaterial - a model defined in Swagger

        :param id: The id of this RelatedMaterial.  # noqa: E501
        :type id: int
        :param identifier: The identifier of this RelatedMaterial.  # noqa: E501
        :type identifier: str
        :param title: The title of this RelatedMaterial.  # noqa: E501
        :type title: str
        :param relation: The relation of this RelatedMaterial.  # noqa: E501
        :type relation: str
        :param identifier_type: The identifier_type of this RelatedMaterial.  # noqa: E501
        :type identifier_type: str
        :param is_linkout: The is_linkout of this RelatedMaterial.  # noqa: E501
        :type is_linkout: bool
        :param link: The link of this RelatedMaterial.  # noqa: E501
        :type link: str
        """
        self.swagger_types = {
            'id': int,
            'identifier': str,
            'title': str,
            'relation': str,
            'identifier_type': str,
            'is_linkout': bool,
            'link': str
        }

        self.attribute_map = {
            'id': 'id',
            'identifier': 'identifier',
            'title': 'title',
            'relation': 'relation',
            'identifier_type': 'identifier_type',
            'is_linkout': 'is_linkout',
            'link': 'link'
        }

        self._id = id
        self._identifier = identifier
        self._title = title
        self._relation = relation
        self._identifier_type = identifier_type
        self._is_linkout = is_linkout
        self._link = link

    @classmethod
    def from_dict(cls, dikt) -> 'RelatedMaterial':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The RelatedMaterial of this RelatedMaterial.  # noqa: E501
        :rtype: RelatedMaterial
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> int:
        """Gets the id of this RelatedMaterial.

        The ID of the related material; can be used to add existing materials of the same account to items.  # noqa: E501

        :return: The id of this RelatedMaterial.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id: int):
        """Sets the id of this RelatedMaterial.

        The ID of the related material; can be used to add existing materials of the same account to items.  # noqa: E501

        :param id: The id of this RelatedMaterial.
        :type id: int
        """

        self._id = id

    @property
    def identifier(self) -> str:
        """Gets the identifier of this RelatedMaterial.

        The related material identifier (e.g., DOI, Handle, ISBN). Mandatory if creating a new material.  # noqa: E501

        :return: The identifier of this RelatedMaterial.
        :rtype: str
        """
        return self._identifier

    @identifier.setter
    def identifier(self, identifier: str):
        """Sets the identifier of this RelatedMaterial.

        The related material identifier (e.g., DOI, Handle, ISBN). Mandatory if creating a new material.  # noqa: E501

        :param identifier: The identifier of this RelatedMaterial.
        :type identifier: str
        """

        self._identifier = identifier

    @property
    def title(self) -> str:
        """Gets the title of this RelatedMaterial.

        The related material title  # noqa: E501

        :return: The title of this RelatedMaterial.
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title: str):
        """Sets the title of this RelatedMaterial.

        The related material title  # noqa: E501

        :param title: The title of this RelatedMaterial.
        :type title: str
        """

        self._title = title

    @property
    def relation(self) -> str:
        """Gets the relation of this RelatedMaterial.

        The relation between the item and the related material; defaults to 'References'. Mandatory if creating a new material.  # noqa: E501

        :return: The relation of this RelatedMaterial.
        :rtype: str
        """
        return self._relation

    @relation.setter
    def relation(self, relation: str):
        """Sets the relation of this RelatedMaterial.

        The relation between the item and the related material; defaults to 'References'. Mandatory if creating a new material.  # noqa: E501

        :param relation: The relation of this RelatedMaterial.
        :type relation: str
        """
        allowed_values = ["IsCitedBy", "Cites", "IsSupplementTo", "IsSupplementedBy", "IsContinuedBy", "Continues", "Describes", "IsDescribedBy", "HasMetadata", "IsMetadataFor", "HasVersion", "IsVersionOf", "IsNewVersionOf", "IsPreviousVersionOf", "IsPartOf", "HasPart", "IsPublishedIn", "IsReferencedBy", "References", "IsDocumentedBy", "Documents", "IsCompiledBy", "Compiles", "IsVariantFormOf", "IsOriginalFormOf", "IsIdenticalTo", "IsReviewedBy", "Reviews", "IsDerivedFrom", "IsSourceOf", "IsRequiredBy", "Requires", "IsObsoletedBy", "Obsoletes"]  # noqa: E501
        if relation not in allowed_values:
            raise ValueError(
                "Invalid value for `relation` ({0}), must be one of {1}"
                .format(relation, allowed_values)
            )

        self._relation = relation

    @property
    def identifier_type(self) -> str:
        """Gets the identifier_type of this RelatedMaterial.

        The type of the identifier of the related material; defaults to 'URL'. Mandatory if creating a new material.  # noqa: E501

        :return: The identifier_type of this RelatedMaterial.
        :rtype: str
        """
        return self._identifier_type

    @identifier_type.setter
    def identifier_type(self, identifier_type: str):
        """Sets the identifier_type of this RelatedMaterial.

        The type of the identifier of the related material; defaults to 'URL'. Mandatory if creating a new material.  # noqa: E501

        :param identifier_type: The identifier_type of this RelatedMaterial.
        :type identifier_type: str
        """
        allowed_values = ["ARK", "arXiv", "bibcode", "DOI", "EAN13", "EISSN", "Handle", "IGSN", "ISBN", "ISSN", "ISTC", "LISSN", "LSID", "PMID", "PURL", "UPC", "URL", "URN", "w3id"]  # noqa: E501
        if identifier_type not in allowed_values:
            raise ValueError(
                "Invalid value for `identifier_type` ({0}), must be one of {1}"
                .format(identifier_type, allowed_values)
            )

        self._identifier_type = identifier_type

    @property
    def is_linkout(self) -> bool:
        """Gets the is_linkout of this RelatedMaterial.

        Flag for highlighting this related material in the call-out box  # noqa: E501

        :return: The is_linkout of this RelatedMaterial.
        :rtype: bool
        """
        return self._is_linkout

    @is_linkout.setter
    def is_linkout(self, is_linkout: bool):
        """Sets the is_linkout of this RelatedMaterial.

        Flag for highlighting this related material in the call-out box  # noqa: E501

        :param is_linkout: The is_linkout of this RelatedMaterial.
        :type is_linkout: bool
        """

        self._is_linkout = is_linkout

    @property
    def link(self) -> str:
        """Gets the link of this RelatedMaterial.

        The full hyperlink for the identifier. Automatically generated by Figshare.  # noqa: E501

        :return: The link of this RelatedMaterial.
        :rtype: str
        """
        return self._link

    @link.setter
    def link(self, link: str):
        """Sets the link of this RelatedMaterial.

        The full hyperlink for the identifier. Automatically generated by Figshare.  # noqa: E501

        :param link: The link of this RelatedMaterial.
        :type link: str
        """

        self._link = link
