# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class Resource(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, id: str='', title: str='', doi: str='', link: str='', status: str='', version: int=0):  # noqa: E501
        """Resource - a model defined in Swagger

        :param id: The id of this Resource.  # noqa: E501
        :type id: str
        :param title: The title of this Resource.  # noqa: E501
        :type title: str
        :param doi: The doi of this Resource.  # noqa: E501
        :type doi: str
        :param link: The link of this Resource.  # noqa: E501
        :type link: str
        :param status: The status of this Resource.  # noqa: E501
        :type status: str
        :param version: The version of this Resource.  # noqa: E501
        :type version: int
        """
        self.swagger_types = {
            'id': str,
            'title': str,
            'doi': str,
            'link': str,
            'status': str,
            'version': int
        }

        self.attribute_map = {
            'id': 'id',
            'title': 'title',
            'doi': 'doi',
            'link': 'link',
            'status': 'status',
            'version': 'version'
        }

        self._id = id
        self._title = title
        self._doi = doi
        self._link = link
        self._status = status
        self._version = version

    @classmethod
    def from_dict(cls, dikt) -> 'Resource':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The Resource of this Resource.  # noqa: E501
        :rtype: Resource
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> str:
        """Gets the id of this Resource.

        ID of resource item  # noqa: E501

        :return: The id of this Resource.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str):
        """Sets the id of this Resource.

        ID of resource item  # noqa: E501

        :param id: The id of this Resource.
        :type id: str
        """
        if id is not None and len(id) > 255:
            raise ValueError("Invalid value for `id`, length must be less than or equal to `255`")  # noqa: E501

        self._id = id

    @property
    def title(self) -> str:
        """Gets the title of this Resource.

        Title of resource item  # noqa: E501

        :return: The title of this Resource.
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title: str):
        """Sets the title of this Resource.

        Title of resource item  # noqa: E501

        :param title: The title of this Resource.
        :type title: str
        """
        if title is not None and len(title) > 1000:
            raise ValueError("Invalid value for `title`, length must be less than or equal to `1000`")  # noqa: E501

        self._title = title

    @property
    def doi(self) -> str:
        """Gets the doi of this Resource.

        DOI of resource item  # noqa: E501

        :return: The doi of this Resource.
        :rtype: str
        """
        return self._doi

    @doi.setter
    def doi(self, doi: str):
        """Sets the doi of this Resource.

        DOI of resource item  # noqa: E501

        :param doi: The doi of this Resource.
        :type doi: str
        """

        self._doi = doi

    @property
    def link(self) -> str:
        """Gets the link of this Resource.

        Link of resource item  # noqa: E501

        :return: The link of this Resource.
        :rtype: str
        """
        return self._link

    @link.setter
    def link(self, link: str):
        """Sets the link of this Resource.

        Link of resource item  # noqa: E501

        :param link: The link of this Resource.
        :type link: str
        """
        if link is not None and len(link) > 255:
            raise ValueError("Invalid value for `link`, length must be less than or equal to `255`")  # noqa: E501

        self._link = link

    @property
    def status(self) -> str:
        """Gets the status of this Resource.

        Status of resource item  # noqa: E501

        :return: The status of this Resource.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status: str):
        """Sets the status of this Resource.

        Status of resource item  # noqa: E501

        :param status: The status of this Resource.
        :type status: str
        """
        if status is not None and len(status) > 100:
            raise ValueError("Invalid value for `status`, length must be less than or equal to `100`")  # noqa: E501

        self._status = status

    @property
    def version(self) -> int:
        """Gets the version of this Resource.

        Version of resource item  # noqa: E501

        :return: The version of this Resource.
        :rtype: int
        """
        return self._version

    @version.setter
    def version(self, version: int):
        """Sets the version of this Resource.

        Version of resource item  # noqa: E501

        :param version: The version of this Resource.
        :type version: int
        """

        self._version = version
