# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class UploadFilePart(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, part_no: int=None, start_offset: int=None, end_offset: int=None, status: str=None, locked: bool=None):  # noqa: E501
        """UploadFilePart - a model defined in Swagger

        :param part_no: The part_no of this UploadFilePart.  # noqa: E501
        :type part_no: int
        :param start_offset: The start_offset of this UploadFilePart.  # noqa: E501
        :type start_offset: int
        :param end_offset: The end_offset of this UploadFilePart.  # noqa: E501
        :type end_offset: int
        :param status: The status of this UploadFilePart.  # noqa: E501
        :type status: str
        :param locked: The locked of this UploadFilePart.  # noqa: E501
        :type locked: bool
        """
        self.swagger_types = {
            'part_no': int,
            'start_offset': int,
            'end_offset': int,
            'status': str,
            'locked': bool
        }

        self.attribute_map = {
            'part_no': 'partNo',
            'start_offset': 'startOffset',
            'end_offset': 'endOffset',
            'status': 'status',
            'locked': 'locked'
        }

        self._part_no = part_no
        self._start_offset = start_offset
        self._end_offset = end_offset
        self._status = status
        self._locked = locked

    @classmethod
    def from_dict(cls, dikt) -> 'UploadFilePart':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The UploadFilePart of this UploadFilePart.  # noqa: E501
        :rtype: UploadFilePart
        """
        return util.deserialize_model(dikt, cls)

    @property
    def part_no(self) -> int:
        """Gets the part_no of this UploadFilePart.

        File part id  # noqa: E501

        :return: The part_no of this UploadFilePart.
        :rtype: int
        """
        return self._part_no

    @part_no.setter
    def part_no(self, part_no: int):
        """Sets the part_no of this UploadFilePart.

        File part id  # noqa: E501

        :param part_no: The part_no of this UploadFilePart.
        :type part_no: int
        """

        self._part_no = part_no

    @property
    def start_offset(self) -> int:
        """Gets the start_offset of this UploadFilePart.

        Indexes on byte range. zero-based and inclusive  # noqa: E501

        :return: The start_offset of this UploadFilePart.
        :rtype: int
        """
        return self._start_offset

    @start_offset.setter
    def start_offset(self, start_offset: int):
        """Sets the start_offset of this UploadFilePart.

        Indexes on byte range. zero-based and inclusive  # noqa: E501

        :param start_offset: The start_offset of this UploadFilePart.
        :type start_offset: int
        """

        self._start_offset = start_offset

    @property
    def end_offset(self) -> int:
        """Gets the end_offset of this UploadFilePart.

        Indexes on byte range. zero-based and inclusive  # noqa: E501

        :return: The end_offset of this UploadFilePart.
        :rtype: int
        """
        return self._end_offset

    @end_offset.setter
    def end_offset(self, end_offset: int):
        """Sets the end_offset of this UploadFilePart.

        Indexes on byte range. zero-based and inclusive  # noqa: E501

        :param end_offset: The end_offset of this UploadFilePart.
        :type end_offset: int
        """

        self._end_offset = end_offset

    @property
    def status(self) -> str:
        """Gets the status of this UploadFilePart.

        part status  # noqa: E501

        :return: The status of this UploadFilePart.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status: str):
        """Sets the status of this UploadFilePart.

        part status  # noqa: E501

        :param status: The status of this UploadFilePart.
        :type status: str
        """
        allowed_values = ["PENDING", "COMPLETE"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def locked(self) -> bool:
        """Gets the locked of this UploadFilePart.

        When a part is being uploaded it is being locked, by setting the locked flag to true. No changes/uploads can happen on this part from other requests.  # noqa: E501

        :return: The locked of this UploadFilePart.
        :rtype: bool
        """
        return self._locked

    @locked.setter
    def locked(self, locked: bool):
        """Sets the locked of this UploadFilePart.

        When a part is being uploaded it is being locked, by setting the locked flag to true. No changes/uploads can happen on this part from other requests.  # noqa: E501

        :param locked: The locked of this UploadFilePart.
        :type locked: bool
        """

        self._locked = locked
