# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.upload_file_part import UploadFilePart
from swagger_server import util


class UploadInfo(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, token: str=None, md5: str=None, size: int=None, name: str=None, status: str=None, parts: List[UploadFilePart]=None):  # noqa: E501
        """UploadInfo - a model defined in Swagger

        :param token: The token of this UploadInfo.  # noqa: E501
        :type token: str
        :param md5: The md5 of this UploadInfo.  # noqa: E501
        :type md5: str
        :param size: The size of this UploadInfo.  # noqa: E501
        :type size: int
        :param name: The name of this UploadInfo.  # noqa: E501
        :type name: str
        :param status: The status of this UploadInfo.  # noqa: E501
        :type status: str
        :param parts: The parts of this UploadInfo.  # noqa: E501
        :type parts: List[UploadFilePart]
        """
        self.swagger_types = {
            'token': str,
            'md5': str,
            'size': int,
            'name': str,
            'status': str,
            'parts': List[UploadFilePart]
        }

        self.attribute_map = {
            'token': 'token',
            'md5': 'md5',
            'size': 'size',
            'name': 'name',
            'status': 'status',
            'parts': 'parts'
        }

        self._token = token
        self._md5 = md5
        self._size = size
        self._name = name
        self._status = status
        self._parts = parts

    @classmethod
    def from_dict(cls, dikt) -> 'UploadInfo':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The UploadInfo of this UploadInfo.  # noqa: E501
        :rtype: UploadInfo
        """
        return util.deserialize_model(dikt, cls)

    @property
    def token(self) -> str:
        """Gets the token of this UploadInfo.

        token received after initializing a file upload  # noqa: E501

        :return: The token of this UploadInfo.
        :rtype: str
        """
        return self._token

    @token.setter
    def token(self, token: str):
        """Sets the token of this UploadInfo.

        token received after initializing a file upload  # noqa: E501

        :param token: The token of this UploadInfo.
        :type token: str
        """

        self._token = token

    @property
    def md5(self) -> str:
        """Gets the md5 of this UploadInfo.

        md5 provided on upload initialization  # noqa: E501

        :return: The md5 of this UploadInfo.
        :rtype: str
        """
        return self._md5

    @md5.setter
    def md5(self, md5: str):
        """Sets the md5 of this UploadInfo.

        md5 provided on upload initialization  # noqa: E501

        :param md5: The md5 of this UploadInfo.
        :type md5: str
        """

        self._md5 = md5

    @property
    def size(self) -> int:
        """Gets the size of this UploadInfo.

        size of file in bytes  # noqa: E501

        :return: The size of this UploadInfo.
        :rtype: int
        """
        return self._size

    @size.setter
    def size(self, size: int):
        """Sets the size of this UploadInfo.

        size of file in bytes  # noqa: E501

        :param size: The size of this UploadInfo.
        :type size: int
        """

        self._size = size

    @property
    def name(self) -> str:
        """Gets the name of this UploadInfo.

        name of file on upload server  # noqa: E501

        :return: The name of this UploadInfo.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name: str):
        """Sets the name of this UploadInfo.

        name of file on upload server  # noqa: E501

        :param name: The name of this UploadInfo.
        :type name: str
        """

        self._name = name

    @property
    def status(self) -> str:
        """Gets the status of this UploadInfo.

        Upload status  # noqa: E501

        :return: The status of this UploadInfo.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status: str):
        """Sets the status of this UploadInfo.

        Upload status  # noqa: E501

        :param status: The status of this UploadInfo.
        :type status: str
        """
        allowed_values = ["PENDING", "COMPLETED", "ABORTED"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def parts(self) -> List[UploadFilePart]:
        """Gets the parts of this UploadInfo.

        Uploads parts  # noqa: E501

        :return: The parts of this UploadInfo.
        :rtype: List[UploadFilePart]
        """
        return self._parts

    @parts.setter
    def parts(self, parts: List[UploadFilePart]):
        """Sets the parts of this UploadInfo.

        Uploads parts  # noqa: E501

        :param parts: The parts of this UploadInfo.
        :type parts: List[UploadFilePart]
        """

        self._parts = parts
